

#include <iostream>
#include <math>

using namespace std;

class Rettangolo {

     float base, altezza;

     public:

     Rettangolo();
     Rettangolo(float, float);
     float area();
     float perimetro();
     float diagonale();

};

     // re-dichiara il costruttore senza parametri
     Rettangolo::Rettangolo()
     {

     }

     // costruttore con parametri -> base e altezza inizializzati
     Rettangolo::Rettangolo(float b, float h)
     {
         base = b;
         altezza = h;
     }

     // soliti metodi di Rettangolo
     float Rettangolo::area()
     {
         return(base * altezza);
     }

     float Rettangolo::perimetro()
     {
         return((base + altezza) * 2);
     }

     float Rettangolo::diagonale()
     {
          return(sqrt(pow(base,2) + pow(altezza,2)));
     }


// classe Quadrato che eredita da Rettangolo
class Quadrato: public Rettangolo
{
     Rettangolo r;     // sfrutta un oggetto Rettangolo per operare su Quadrato

     public:

     Quadrato(float);
     float area();
     float perimetro();
     float diagonale();
};

// dato il lato del quadrato inizializza il relativo Rettangolo
// come un caso particolare (base = altezza)

Quadrato::Quadrato(float lato)
{
    r = Rettangolo(lato, lato);
}


// sfrutta per implementare ogni metodo
// di Quadrato gli analoghi di Rettangolo
float Quadrato::area()
{
    return(r.area());
}

float Quadrato::perimetro()
{
   return(r.perimetro());
}

float Quadrato::diagonale()
{
    return(r.diagonale());
}


int main()
{
    Quadrato q(10);     // creazione con inizializzazione di un oggetto Quadrato

    // applicazione dei metodi di Quadrato
    cout << "Area quadrato:  " << q.area() << endl;
    cout << "Perimetro quadrato:  " << q.perimetro() << endl;
    cout << "Diagonale quadrato:  " << q.diagonale() << endl;

    cin.get();    // attende Enter per uscire

    return 0;
}


 